﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IsbnCheckSum.Validation
{
	/// <summary>
	/// Extends the core validation interface with some more domain-specific extensions to keep code
	/// as DRY as possible.
	/// </summary>
	public interface ICanValidateIsbnCodeFormats : ICanValidate<string>	
	{
		/// <summary>
		/// Tests whether the code supplied contains a check-sum already
		/// </summary>
		bool CodeContainsCheckSum(string isbnCode);
	}
}
