﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using IsbnCheckSum.Calculation;
using IsbnCheckSum.Validation;

namespace IsbnCheckSum.Interface.WPF
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

		private void btnSubmit_Click(object sender, RoutedEventArgs e)
		{
			IsbnCode result = new IsbnCode(txtCodeEntry.Text, new NumericMod11CheckSumCalculator(), new IsbnCodeFormatValidator());

			if (result.IsValid())
			{
				lblBaseSequence_Value.Content = result.BaseSequence;
				lblCheckDigit_Value.Content = result.CheckSumDigit.ToString();
				lblFullIsbn_Value.Content = result.Code;
				txtCodeEntry.Text = result.Code;
			}
			else
			{
				var errors = result.GetValidationErrors().Select(s => "* " + s);
				MessageBox.Show("There were some validation errors. Please review and try again: \n\n" + String.Join("\n", errors));

				lblBaseSequence_Value.Content = "-";
				lblCheckDigit_Value.Content = "-";
				lblFullIsbn_Value.Content = "-";
			}
		}
	}
}
